
let FeedbackForm = {
    props: ['action', 'message'],
    template: '#feedback-template',
    methods: {

        showFeedback() {
            this.showDialog = true
            this.$nextTick(function() {
                this.$refs.textarea.focus()
            })
        },

        sendFeedback() {

            let params = {
                referrer: this.referrer,
                user: this.userUUID,
                user_name: this.userName,
                message: this.message.trim(),
            }

            let headers = {
                // TODO: should find a better way to handle CSRF token
                'X-CSRF-TOKEN': this.csrftoken,
            }

            this.$http.post(this.action, params, {headers: headers}).then(({ data }) => {
                if (data.ok) {
                    alert("Message successfully sent.\n\nThank you for your feedback.")
                    this.showDialog = false
                    // clear out message, in case they need to send another
                    this.message = ""
                } else {
                    this.$buefy.toast.open({
                        message: "Failed to send feedback:  " + data.error,
                        type: 'is-danger',
                        duration: 4000, // 4 seconds
                    })
                }
            }, response => {
                this.$buefy.toast.open({
                    message: "Failed to send feedback!  (unknown server error)",
                    type: 'is-danger',
                    duration: 4000, // 4 seconds
                })
            })
        },
    }
}

let FeedbackFormData = {
    referrer: null,
    userUUID: null,
    userName: null,
    showDialog: false,
}
